#!/usr/bin/perl
#sserver.pl:

# openssl s_client -connect localhost:11211
#
# a test server for "New Gopher"
#
use strict;
use warnings;

use TLSGopher;
use File::MimeInfo; # CPAN

if (!$ARGV[0]) {
	die "Usage: ./sslserver.pl CONFIG-FILE";
}

sub read_config {
	my $filename = shift;
	my %defaults = (
		'Host'=>'localhost',
		'Port'=>32070,
		'Root'=>undef,
		'Debug'=>1,
		'TLSoff'=>0,
		'TLSkey'=>'server.key',
		'TLScert'=>'server.crt',
		'TLSpassphrase'=>''
	);
	my $fh;
	open $fh, $filename;
	while (<$fh>) { my $line = $_;
		if ($line =~ /^#/) { next; } #comments
		$line =~ /(\S+)\s+(.+)/;
		my ($key, $val) = ($1, $2);
		if (exists $defaults{$key}) {
			$defaults{$key} = $val;
		} else {
			warn "Unknown config entry '".$key."'";
		}
	}
	close $fh;
	if (!($defaults{'Root'} =~ /\/$/)) { $defaults{'Root'} .= '/'; } 
	return %defaults;
}

my %config = read_config($ARGV[0]);

(my $server = new TLSGopher::server \%config)
	||
	die "unable to create socket: ", TLSGopher::server::errstr, "\n";

$server->register(
	accept	=> \&cb_accept,
	close	=> \&cb_close,
	request	=> \&cb_request,
#	read	=> \&cb_read,
);

	print "Waiting for connections.\n";

$server->listen();

sub cb_accept {
	print "Connection accepted\n";
}

sub cb_close {
	print "Connection closed\n\n";
}

sub cb_request {
	my ($conn, $resp, $req) = @_;

	my $selector = safer_selector($req->{selector});

	print "Responding to request '$selector'\n";

	my $path = $config{'Root'} . $selector;

	if (-e $path && !-r $path) {
		respond_with_error($resp, "Access denied", "You requested '".$resp->{selector}."'");
	    return 0;
	}

	if (-f $path) {
		if (-x $path) {
			# CGI script
			print "Running script '$path'\n";
			exec_cgi($path, $resp, $req);
		} else {
			# FS file
			print "Sending file '$path'\n";
			my $size = -s $path;
			my $mimetype = mimetype $path;
			open(FILE, $path);
			binmode(FILE);
			$resp->raw(1);
	 		$resp->write($size."\t".$mimetype."\r\n");
	 		$resp->read_from(*FILE);
	    }
	    return 0;
	}
	if (-d $path) {
		print "Generating menu '$path'\n";
		$resp->type('text/x-menu');
	    $resp->write( ng_menu_from_dir($path) );
	    write_banner($resp);
	    return 0;
	}

	respond_with_error($resp, "File not found", "You requested '".$resp->{selector}."'");
	return 0;
}

sub cb_read {
	my ($conn, $data, $n) = @_;
#	print "RAW data being read: ($n) $data";
}

sub ng_menu_from_dir {
	my $path = shift;
	my $buf = "";
	$path =~ s/\/$//;
    my @files = glob $path."/*";
    $buf .= "i\tListing [".$path."]\r\n";
    $buf .= "m\t..\t..\r\n";
    my $l = length $path;
    my $sl = length $config{'Root'};
    foreach my $file (@files) {
		my $name = substr($file, $l + 1);
		my $selector = substr($file, $sl);
		my $type = 'b';
		if (-x $file) { $type = 's'; }
		if (-d $file) { $type = 'm'; }
		$buf .= $type."\t".$name."\t".$selector."\r\n";
    }
	return $buf;
}

sub safer_selector {
	my $selector = shift;
	if (!defined $selector) { $selector = ''; }
	# Make selector 'safe' :(
	$selector = '/'.$selector;
	$selector =~ s/\/\.+//;
	$selector =~ s/\.\///;
	$selector =~ s/^\/+//;
	$selector =~ s/\/$//;
	$selector =~ s/\r//;
	$selector =~ s/\n//m;
	return $selector;
}

sub respond_with_error {
	my $r = shift;
	$r->error( @_ );
	$r->write("m\tReturn to root\t/\r\n");
	write_banner($r);
	print "Responding with error: " . $_[0]."\n";
}
sub write_banner {
	$_[0]->write("i\t________________________________\r\n");
	$_[0]->write("i\t_generated by_[blahblah uname]__\r\n");
}

sub exec_cgi {
	my ($path, $resp, $req) = @_;

#    use IO::Handle;               # thousands of lines just for autoflush :-(
    pipe(PARENT_RDR, CHILD_WTR);  # XXX: check failure?
    pipe(CHILD_RDR,  PARENT_WTR); # XXX: check failure?
#    CHILD_WTR->autoflush(1);
#    PARENT_WTR->autoflush(1);
	my $pid = fork;

	if (!defined $pid) {	# Fork failed, return error
		print "FAILED TO FORK, FATAL ERROR\n";
		close CHILD_RDR; 
        close CHILD_WTR;
		close PARENT_RDR; 
        close PARENT_WTR;
		return 1;
	}

	if ($pid == 0) {	# Child
        close CHILD_RDR; 
        close CHILD_WTR;
        open STDOUT, '>&'.'PARENT_WTR' || die "can't reopen stdout\n";
		open STDIN, '<&'.'PARENT_RDR' || die "can't reopen stdin\n";
		open STDERR, '> '.'/dev/null' || die "can't reopen stderr\n";

		$ENV{"PATH_INFO"} = $req->{selector};	# HTTP/1.1 compatibility
		$ENV{"SELECTOR"} = $req->{selector};	# varied old gopher compatibility

		$ENV{"GOPHER_SELECTOR"} = $req->{selector};
		$ENV{"QUERY_STRING"} = $req->{search};
		$ENV{'CONTENT_SIZE'} = $req->{post_size};
		$ENV{'CONTENT_TYPE'} = $req->{post_type};
		$ENV{"SCRIPT_NAME"} = $path;

		exec $path;
	}

	else { # Parent
	 	$SIG{PIPE} = "IGNORE";
#		print "Forked a CHILD\n";
        close PARENT_RDR;
        close PARENT_WTR;
        $req->write_to(*CHILD_WTR);
        $resp->raw(1);
        $resp->read_from(*CHILD_RDR);
        $resp->track_pid($pid); # Do not unqueue $resp until child process is finished
	}
	return 0;
}
